#include<iostream.h>

class MySet
{

private:
	//   
	int* m_Set;	
	// Ǿ ִ  
	int	m_Size;
	//   ִ ũ
	int m_MaxSize;

public:
	//⺻ 
	MySet()
	{
		m_Size = 0;
		m_MaxSize = 100;
		m_Set = new int[m_MaxSize];
	};

	//ϴ   
	MySet(int agSize)
	{
		m_Size = 0;
		m_MaxSize = agSize;
		m_Set = new int[m_MaxSize];
	};

	// Ҷ ʱȭϱ  
	MySet(int* agSet, int agSize)
	{
		int i = 0;

		m_Size = 0;
		m_MaxSize = 100;
		m_Set = new int[m_MaxSize];

		for(i = 0; i < agSize; i++)
			m_Set[i] = agSet[i];

		m_Size = agSize;
	};
	
	//Ҹ
	~MySet()
	{
		if (!m_Set)
		{
			delete[] m_Set;
			m_Set = NULL;
		}
	}

public:
	int GetSize() 
	{
		return m_Size;
	}

	//ϴ ġ Ҹ о
	int GetItem(int agIndex)
	{
		return m_Set[agIndex];
	}

	//  Ǿ ִ   ڿ ο ڸ Է
	void AddItem(int agValue)
	{
		if (m_Size < m_MaxSize)
			m_Set[m_Size++] = agValue;
	}	

	//  Ǿ ִ  .
	void Print()
	{
		cout << "{ ";
		for(int i = 0; i < m_Size - 1; i++)		
		{			
			cout << m_Set[i] << ", ";		
		}
		cout << m_Set[i] << " }\n";
	}

	//   ߺ Լ
	MySet operator^(MySet right);
	//   ߺ Լ
	MySet operator*(MySet right);

};

MySet MySet::operator^(MySet right)
{
	MySet tmpSet;

	for(int i = 0; i < GetSize(); i++)
	{
		for(int j = 0; j < right.GetSize(); j++)
			if (GetItem(i) == right.GetItem(j))
			{
				tmpSet.AddItem(GetItem(i));
				break;
			}
	}	

	return tmpSet;
}

MySet MySet::operator*(MySet right)
{
	int flag = 0;
	MySet tmpSet;

	for(int i = 0; i < GetSize(); i++)	
		tmpSet.AddItem(GetItem(i));		
	
	for(int j = 0; j < right.GetSize(); j++)
	{
		flag = 0;
		for(int i = 0; i < tmpSet.GetSize(); i++)
			if (tmpSet.GetItem(i) == right.GetItem(j))
			{
				flag = 1;
				break;
			}

		if (flag == 0) tmpSet.AddItem(right.GetItem(j));	
	}

	return tmpSet;
}

void main()
{
	int s1[] = { 1, 3, 5, 7 , 9 , 11};
	int s2[] = { 11, 13, 7 , 9 , 20};

	MySet set1(s1, 6);
	MySet set2(s2, 5);
	
	cout << "SET1 = { 1, 3, 5, 7 , 9 , 11}\n";
	cout << "SET2 = { 11, 13, 7 , 9 , 20}\n";

	//    
	MySet Inter;

	Inter = set1^set2;

	cout << "SET1 ^ SET2 = ";
	Inter.Print();

	//   
	MySet Uni;

	Uni = set1*set2;

	cout << "SET1 * SET2 = ";
	Uni.Print();
}

