#include<iostream.h>

class exception {
	char* szCaption;
public:
	exception(char* in){ 
		szCaption=in; 
	}
	void printout(){
		cout << szCaption << endl;
	}
};

class Zero_Exception : public exception {
public:
	Zero_Exception( char* in ) : exception( in ) {
	}
};

class Minus_Exception : public exception {
public:
	Minus_Exception( char* in ) : exception( in ) {
	}
};

class Rectangle {
	int width, height;
public:
	Rectangle( int x,int y ) {
		if ( x==0 || y==0 ) {
			Zero_Exception e("zero exception occurs");
			throw e;
		}
		if ( x<0 || y<0 ) {
			Minus_Exception e("minus exception occurs");
			throw e;
		}
		width=x; height=y;
	}
};

void test_exception( int x, int y)
{
	try
	{
		Rectangle rect( x, y ); 
	}
	catch( exception e )
	{
		e.printout();
	}
}

int main(int argc, char* argv[])
{
	//  쿡  .
	test_exception( 1, 1 );

	//  쿡 Zero_Exception ߻.
	test_exception( 0, 2 );

	//  쿡 Minus_Exception ߻.
	test_exception( 3, -1 );

    return 0;
}
